# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

import os
import os.path as os
import gzip
import re
import time
import urllib
import tempfile
import glob
from base.g import *
from base import utils

try:
    import cupsext
except ImportError:
    pass

nickname_pat = re.compile('\\*NickName:\\s*\\"(.*)"', re.MULTILINE)
IPP_PRINTER_STATE_IDLE = 3
IPP_PRINTER_STATE_PROCESSING = 4
IPP_PRINTER_STATE_STOPPED = 5
PPD_UI_BOOLEAN = 0
PPD_UI_PICKONE = 1
PPD_UI_PICKMANY = 2
UI_SPINNER = 100
UI_UNITS_SPINNER = 101
UI_BANNER_JOB_SHEETS = 102
IPP_PAUSE_PRINTER = 16
IPP_RESUME_PRINTER = 17
IPP_PURGE_JOBS = 18
CUPS_GET_DEFAULT = 16385
CUPS_GET_PRINTERS = 16386
CUPS_ADD_MODIFY_PRINTER = 16387
CUPS_DELETE_PRINTER = 16388
CUPS_GET_CLASSES = 16389
CUPS_ADD_MODIFY_CLASS = 16390
CUPS_DELETE_CLASS = 16391
CUPS_ACCEPT_JOBS = 16392
CUPS_REJECT_JOBS = 16393
CUPS_SET_DEFAULT = 16394
CUPS_GET_DEVICES = 16395
CUPS_GET_PPDS = 16396
CUPS_MOVE_JOB = 16397
CUPS_AUTHENTICATE_JOB = 16398
IPP_JOB_PENDING = 3
IPP_JOB_HELD = 4
IPP_JOB_PROCESSING = 5
IPP_JOB_STOPPED = 6
IPP_JOB_CANCELLED = 7
IPP_JOB_ABORTED = 8
IPP_JOB_COMPLETED = 8
IPP_OK = 0
IPP_OK_SUBST = 1
IPP_OK_CONFLICT = 2
IPP_OK_IGNORED_SUBSCRIPTIONS = 3
IPP_OK_IGNORED_NOTIFICATIONS = 4
IPP_OK_TOO_MANY_EVENTS = 5
IPP_OK_BUT_CANCEL_SUBSCRIPTION = 6
IPP_OK_EVENTS_COMPLETE = 7
IPP_REDIRECTION_OTHER_SITE = 768
IPP_BAD_REQUEST = 1024
IPP_FORBIDDEN = 1025
IPP_NOT_AUTHENTICATED = 1026
IPP_NOT_AUTHORIZED = 1027
IPP_NOT_POSSIBLE = 1028
IPP_TIMEOUT = 1029
IPP_NOT_FOUND = 1030
IPP_GONE = 1031
IPP_REQUEST_ENTITY = 1032
IPP_REQUEST_VALUE = 1033
IPP_DOCUMENT_FORMAT = 1034
IPP_ATTRIBUTES = 1035
IPP_URI_SCHEME = 1036
IPP_CHARSET = 1037
IPP_CONFLICT = 1038
IPP_COMPRESSION_NOT_SUPPORTED = 1039
IPP_COMPRESSION_ERROR = 1040
IPP_DOCUMENT_FORMAT_ERROR = 1041
IPP_DOCUMENT_ACCESS_ERROR = 1042
IPP_ATTRIBUTES_NOT_SETTABLE = 1043
IPP_IGNORED_ALL_SUBSCRIPTIONS = 1044
IPP_TOO_MANY_SUBSCRIPTIONS = 1045
IPP_IGNORED_ALL_NOTIFICATIONS = 1046
IPP_PRINT_SUPPORT_FILE_NOT_FOUND = 1047
IPP_INTERNAL_ERROR = 1280
IPP_OPERATION_NOT_SUPPORTED = 1281
IPP_SERVICE_UNAVAILABLE = 1282
IPP_VERSION_NOT_SUPPORTED = 1283
IPP_DEVICE_ERROR = 1284
IPP_TEMPORARY_ERROR = 1285
IPP_NOT_ACCEPTING = 1286
IPP_PRINTER_BUSY = 1287
IPP_ERROR_JOB_CANCELLED = 1288
IPP_MULTIPLE_JOBS_NOT_SUPPORTED = 1289
IPP_PRINTER_IS_DEACTIVATED = 1290
CUPS_ERROR_BAD_NAME = 3840
CUPS_ERROR_BAD_PARAMETERS = 3841

def restartCUPS():
    os.system('killall -HUP cupsd')


def getPPDPath(addtional_paths = None):
    '''
        Returns the CUPS ppd path (not the foomatic one under /usr/share/ppd).
        Usually this is /usr/share/cups/model.
    '''
    if addtional_paths is None:
        addtional_paths = []
    
    search_paths = prop.ppd_search_path.split(';') + addtional_paths
    for path in search_paths:
        ppd_path = os.path.join(path, 'cups/model')
        if os.path.exists(ppd_path):
            return ppd_path
            continue
    


def getAllowableMIMETypes():
    '''
        Scan all /etc/cups/*.convs files for allowable file formats.
    '''
    files = glob.glob('/etc/cups/*.convs')
    allowable_mime_types = []
    for f in files:
        conv_file = file(f, 'r')
        for line in conv_file:
            if not line.startswith('#') and len(line) > 1:
                
                try:
                    (source, dest, cost, prog) = line.split()
                except ValueError:
                    continue

                if source not in ('application/octet-stream', 'application/vnd.cups-postscript'):
                    allowable_mime_types.append(source)
                
            source not in ('application/octet-stream', 'application/vnd.cups-postscript')
        
    
    allowable_mime_types.append('image/x-bmp')
    allowable_mime_types.append('text/cpp')
    return allowable_mime_types


def getPPDDescription(f):
    if f.endswith('.gz'):
        nickname = gzip.GzipFile(f, 'r').read(4096)
    else:
        nickname = file(f, 'r').read(4096)
    
    try:
        desc = nickname_pat.search(nickname).group(1)
    except AttributeError:
        desc = ''

    return desc


def getSystemPPDs():
    (major, minor, patch) = getVersionTuple()
    ppds = { }
    if major == 1 and minor < 2:
        log.debug('(CUPS 1.1.x) Searching for PPDs in: %s' % sys_cfg.dirs.ppd)
        for f in utils.walkFiles(sys_cfg.dirs.ppd, pattern = 'HP*ppd*;hp*ppd*', abs_paths = True):
            desc = getPPDDescription(f)
            ppds[f] = desc
            log.debug('%s: %s' % (f, desc))
        
    else:
        log.debug('(CUPS 1.2.x) Getting list of PPDs using CUPS_GET_PPDS...')
        ppd_dict = cupsext.getPPDList()
        cups_ppd_path = getPPDPath()
        foomatic_ppd_path = sys_cfg.dirs.ppdbase
        if not foomatic_ppd_path or not os.path.exists(foomatic_ppd_path):
            foomatic_ppd_path = '/usr/share/ppd'
        
        log.debug('CUPS PPD base path = %s' % cups_ppd_path)
        log.debug('Foomatic PPD base path = %s' % foomatic_ppd_path)
        for ppd in ppd_dict:
            if ('HP-' in ppd or 'HP_' in ppd) and ppd_dict[ppd]['ppd-make'] == 'HP':
                desc = ppd_dict[ppd]['ppd-make-and-model']
                path = os.path.join(foomatic_ppd_path, ppd)
                if not os.path.exists(path):
                    path = os.path.join(cups_ppd_path, ppd)
                    if not os.path.exists(path):
                        path = ppd
                    
                
                ppds[path] = desc
                log.debug('%s: %s' % (path, desc))
                continue
        
    return ppds


def levenshtein_distance(a, b):
    '''
    Calculates the Levenshtein distance between a and b.
    Written by Magnus Lie Hetland.
    '''
    n = len(a)
    m = len(b)
    if n > m:
        a = b
        b = a
        n = m
        m = n
    
    current = range(n + 1)
    for i in range(1, m + 1):
        previous = current
        current = [
            i] + [
            0] * m
        for j in range(1, n + 1):
            add = previous[j] + 1
            delete = current[j - 1] + 1
            change = previous[j - 1]
            if a[j - 1] != b[i - 1]:
                change = change + 1
            
            current[j] = min(add, delete, change)
        
    
    return current[n]

number_pat = re.compile('.*?(\\d+)', re.IGNORECASE)

def getPPDFile(stripped_model, ppds):
    '''
        Match up a model name to a PPD from a list of system PPD files.
    '''
    log.debug('1st stage edit distance match')
    mins = { }
    eds = { }
    min_edit_distance = sys.maxint
    for f in ppds:
        t = os.path.basename(f).lower().replace('hp-', '').replace('-hpijs', '').replace('.gz', '').replace('.ppd', '').replace('hp_', '').replace('_series', '').replace('foomatic:', '').lower()
        eds[f] = levenshtein_distance(stripped_model, t)
        log.debug("dist('%s', '%s') = %d" % (stripped_model, t, eds[f]))
        min_edit_distance = min(min_edit_distance, eds[f])
    
    log.debug('Min. dist = %d' % min_edit_distance)
    for f in ppds:
        if eds[f] == min_edit_distance:
            for m in mins:
                if os.path.basename(m) == os.path.basename(f):
                    break
                    continue
            else:
                mins[f] = ppds[f]
    
    log.debug(mins)
    if len(mins) > 1:
        log.debug('2nd stage matching with model number')
        
        try:
            model_number = number_pat.match(stripped_model).group(1)
            model_number = int(model_number)
        except AttributeError:
            pass
        except ValueError:
            pass

        log.debug('model_number=%d' % model_number)
        matches = { }
        for x in range(3):
            factor = 10 ** x
            log.debug('Factor = %d' % factor)
            adj_model_number = int(model_number / factor) * factor
            (number_matching, match) = (0, '')
            for m in mins:
                
                try:
                    mins_model_number = number_pat.match(os.path.basename(m)).group(1)
                    mins_model_number = int(mins_model_number)
                    log.debug('mins_model_number= %d' % mins_model_number)
                except AttributeError:
                    continue
                except ValueError:
                    continue

                mins_adj_model_number = int(mins_model_number / factor) * factor
                log.debug('mins_adj_model_number=%d' % mins_adj_model_number)
                log.debug('adj_model_number=%d' % adj_model_number)
                if mins_adj_model_number == adj_model_number:
                    log.debug('match')
                    number_matching += 1
                    matches[m] = ppds[m]
                    log.debug(matches)
                
                log.debug('***')
            
            if len(matches):
                mins = matches
                break
                continue
        
    
    return mins


def getDefaultPrinter():
    return cupsext.getDefaultPrinter()


def setDefaultPrinter(printer_name):
    return cupsext.setDefaultPrinter(printer_name)


def accept(printer_name):
    return controlPrinter(printer_name, CUPS_ACCEPT_JOBS)


def reject(printer_name):
    return controlPrinter(printer_name, CUPS_REJECT_JOBS)


def start(printer_name):
    return controlPrinter(printer_name, IPP_RESUME_PRINTER)


def stop(printer_name):
    return controlPrinter(printer_name, IPP_PAUSE_PRINTER)


def purge(printer_name):
    return controlPrinter(printer_name, IPP_PURGE_JOBS)


def controlPrinter(printer_name, cups_op):
    if cups_op in (CUPS_ACCEPT_JOBS, CUPS_REJECT_JOBS, IPP_PAUSE_PRINTER, IPP_RESUME_PRINTER, IPP_PURGE_JOBS):
        return cupsext.controlPrinter(printer_name, cups_op)
    
    return 0


def openPPD(printer):
    if not printer:
        return None
    
    return cupsext.openPPD(printer)


def closePPD():
    return cupsext.closePPD()


def getPPD(printer):
    if not printer:
        return None
    
    return cupsext.getPPD(printer)


def getPPDOption(option):
    return cupsext.getPPDOption(option)


def getPPDPageSize():
    return cupsext.getPPDPageSize()


def getPrinters():
    return cupsext.getPrinters()


def getJobs(my_job = 0, completed = 0):
    return cupsext.getJobs(my_job, completed)


def getAllJobs(my_job = 0):
    return cupsext.getJobs(my_job, 0) + cupsext.getJobs(my_job, 1)


def getVersion():
    return cupsext.getVersion()


def getVersionTuple():
    return cupsext.getVersionTuple()


def getServer():
    return cupsext.getServer()


def cancelJob(jobid, dest = None):
    if dest is not None:
        return cupsext.cancelJob(dest, jobid)
    else:
        jobs = cupsext.getJobs(0, 0)
        for j in jobs:
            if j.id == jobid:
                return cupsext.cancelJob(j.dest, jobid)
                continue
        
    return False


def resetOptions():
    return cupsext.resetOptions()


def addOption(option):
    return cupsext.addOption(option)


def getOptions():
    return cupsext.getOptions()


def printFile(printer, filename, title):
    if os.path.exists(filename):
        return cupsext.printFileWithOptions(printer, filename, title)
    else:
        return -1


def addPrinter(printer_name, device_uri, location, ppd_file, model, info):
    log.debug("addPrinter('%s', '%s', '%s', '%s', '%s', '%s')" % (printer_name, device_uri, location, ppd_file, model, info))
    if ppd_file and not os.path.exists(ppd_file):
        log.error("PPD file '%s' not found." % ppd_file)
        return (-1, 'PPD file not found')
    
    return cupsext.addPrinter(printer_name, device_uri, location, ppd_file, model, info)


def delPrinter(printer_name):
    return cupsext.delPrinter(printer_name)


def getGroupList():
    return cupsext.getGroupList()


def getGroup(group):
    return cupsext.getGroup(group)


def getOptionList(group):
    return cupsext.getOptionList(group)


def getOption(group, option):
    return cupsext.getOption(group, option)


def getChoiceList(group, option):
    return cupsext.getChoiceList(group, option)


def getChoice(group, option, choice):
    return cupsext.getChoice(group, option, choice)


def setOptions():
    return cupsext.setOptions()


def removeOption(option):
    return cupsext.removeOption(option)


def setPasswordCallback(func):
    return cupsext.setPasswordCallback(func)

