# Source Generated with Decompyle++
# File: in.pyc (Python 2.5)

from base.g import *
from base import utils
from qt import *
from scrollview import ScrollView
import os.path as os
import os

class ScrollFunctionsView(ScrollView):
    
    def __init__(self, cmd_print, cmd_print_int, cmd_scan, cmd_scan_int, cmd_pcard, cmd_pcard_int, cmd_fax, cmd_fax_int, cmd_copy, cmd_copy_int, parent = None, form = None, name = None, fl = 0):
        ScrollView.__init__(self, parent, name, fl)
        self.cmd_print = cmd_print
        self.cmd_print_int = cmd_print_int
        self.cmd_scan = cmd_scan
        self.cmd_scan_int = cmd_scan_int
        self.cmd_copy = cmd_copy
        self.cmd_copy_int = cmd_copy_int
        self.cmd_pcard = cmd_pcard
        self.cmd_pcard_int = cmd_pcard_int
        self.cmd_fax = cmd_fax
        self.cmd_fax_int = cmd_fax_int
        self.form = form
        self.ScanPixmap = QPixmap(os.path.join(prop.image_dir, 'scan_icon.png'))
        self.PrintPixmap = QPixmap(os.path.join(prop.image_dir, 'print_icon.png'))
        self.SendFaxPixmap = QPixmap(os.path.join(prop.image_dir, 'fax_icon.png'))
        self.PhotoCardPixmap = QPixmap(os.path.join(prop.image_dir, 'pcard_icon.png'))
        self.MakeCopiesPixmap = QPixmap(os.path.join(prop.image_dir, 'makecopies_icon.png'))

    
    def setCmds(self, cmd_print, cmd_scan, cmd_pcard, cmd_fax, cmd_copy):
        self.cmd_print = cmd_print
        self.cmd_scan = cmd_scan
        self.cmd_copy = cmd_copy
        self.cmd_pcard = cmd_pcard
        self.cmd_fax = cmd_fax

    
    def fillControls(self):
        ScrollView.fillControls(self)
        if self.cur_device is not None and self.cur_device.supported and self.cur_device.device_state != DEVICE_STATE_NOT_FOUND:
            if self.cmd_print_int:
                s = self._ScrollFunctionsView__tr('Print >>')
            else:
                s = self._ScrollFunctionsView__tr('Print...')
            self.addItem(self._ScrollFunctionsView__tr('<b>Print</b>'), self._ScrollFunctionsView__tr('Print documents or files.'), s, self.PrintPixmap, self.PrintButton_clicked)
            if self.cur_device.scan_type:
                if self.cmd_scan_int:
                    s = self._ScrollFunctionsView__tr('Scan >>')
                else:
                    s = self._ScrollFunctionsView__tr('Scan...')
                self.addItem(self._ScrollFunctionsView__tr('<b>Scan</b>'), self._ScrollFunctionsView__tr('Scan a document or image.'), s, self.ScanPixmap, self.ScanButton_clicked)
            
            if self.cur_device.fax_type:
                if self.cmd_fax_int:
                    s = self._ScrollFunctionsView__tr('Send PC Fax >>')
                else:
                    s = self._ScrollFunctionsView__tr('Send PC Fax...')
                self.addItem(self._ScrollFunctionsView__tr('<b>Send PC Fax</b>'), self._ScrollFunctionsView__tr('Send a fax from the PC.'), s, self.SendFaxPixmap, self.SendFaxButton_clicked)
            
            if self.cur_device.copy_type:
                if self.cmd_copy_int:
                    s = self._ScrollFunctionsView__tr('Make Copies >>')
                else:
                    s = self._ScrollFunctionsView__tr('Make Copies...')
                self.addItem(self._ScrollFunctionsView__tr('<b>Make Copies</b>'), self._ScrollFunctionsView__tr('Make copies'), s, self.MakeCopiesPixmap, self.MakeCopiesButton_clicked)
            
            if self.cur_device.pcard_type:
                if self.cmd_pcard_int:
                    s = self._ScrollFunctionsView__tr('Unload Photo Card >>')
                else:
                    s = self._ScrollFunctionsView__tr('Unload Photo Card...')
                self.addItem(self._ScrollFunctionsView__tr('<b>Unload Photo Card</b>'), self._ScrollFunctionsView__tr('Copy images the device to the PC.'), s, self.PhotoCardPixmap, self.PCardButton_clicked)
            
        elif not self.cur_device.supported:
            self.addGroupHeading('not_supported', self._ScrollFunctionsView__tr('ERROR: Device not supported.'))
        else:
            self.addGroupHeading('not_found', self._ScrollFunctionsView__tr('ERROR: Device not found. Please check connection and power-on device.'))

    
    def PrintButton_clicked(self):
        if self.cmd_print_int:
            self.form.SwitchFunctionsTab('print')
        else:
            self.RunCommand(self.cmd_print)

    
    def ScanButton_clicked(self):
        if self.cmd_scan_int:
            self.form.SwitchFunctionsTab('scan')
        else:
            self.RunCommand(self.cmd_scan)

    
    def PCardButton_clicked(self):
        if self.cur_device.pcard_type == PCARD_TYPE_MLC:
            if self.cmd_pcard_int:
                self.form.SwitchFunctionsTab('pcard')
            else:
                self.RunCommand(self.cmd_pcard)
        elif self.cur_device.pcard_type == PCARD_TYPE_USB_MASS_STORAGE:
            self.FailureUI(self._ScrollFunctionsView__tr("<p><b>Photocards on your printer are only available by mounting them as drives using USB mass storage.</b><p>Please refer to your distribution's documentation for setup and usage instructions."))
        

    
    def SendFaxButton_clicked(self):
        if self.cmd_fax_int:
            self.form.SwitchFunctionsTab('fax')
        else:
            self.RunCommand(self.cmd_fax)

    
    def MakeCopiesButton_clicked(self):
        if self.cmd_copy_int:
            self.form.SwitchFunctionsTab('copy')
        else:
            self.RunCommand(self.cmd_copy)

    
    def RunCommand(self, cmd, macro_char = '%'):
        QApplication.setOverrideCursor(QApplication.waitCursor)
        
        try:
            if len(cmd) == 0:
                self.FailureUI(self._ScrollFunctionsView__tr('<p><b>Unable to run command. No command specified.</b><p>Use <pre>Configure...</pre> to specify a command to run.'))
                log.error('No command specified. Use settings to configure commands.')
            else:
                log.debug(utils.bold('Run: %s %s (%s) %s' % ('********************', cmd, self.cur_device.device_uri, '********************')))
                log.debug(cmd)
                cmd = []([ self.cur_device.device_vars.get(x, x) for x in cmd.split(macro_char) ])
                log.debug(cmd)
                path = cmd.split()[0]
                args = cmd.split()
                log.debug(path)
                log.debug(args)
                self.CleanupChildren()
                os.spawnvp(os.P_NOWAIT, path, args)
        finally:
            QApplication.restoreOverrideCursor()


    
    def CleanupChildren(self):
        log.debug('Cleaning up child processes.')
        
        try:
            os.waitpid(-1, os.WNOHANG)
        except OSError:
            pass


    
    def addItem(self, title, text, button_text, pixmap, button_func):
        widget = self.getWidget()
        self.addGroupHeading(title, title)
        layout1 = QGridLayout(widget, 1, 3, 5, 10, 'layout1')
        layout1.setColStretch(0, 1)
        layout1.setColStretch(1, 10)
        layout1.setColStretch(2, 2)
        pushButton = QPushButton(widget, 'pushButton')
        pushButton.setSizePolicy(QSizePolicy(QSizePolicy.Preferred, QSizePolicy.Fixed, 0, 0, pushButton.sizePolicy().hasHeightForWidth()))
        layout1.addWidget(pushButton, 0, 3)
        icon = QLabel(widget, 'icon')
        icon.setSizePolicy(QSizePolicy(QSizePolicy.Fixed, QSizePolicy.Fixed, 0, 0, icon.sizePolicy().hasHeightForWidth()))
        icon.setMinimumSize(QSize(32, 32))
        icon.setMaximumSize(QSize(32, 32))
        icon.setScaledContents(1)
        layout1.addWidget(icon, 0, 0)
        textLabel = QLabel(widget, 'textLabel')
        textLabel.setAlignment(QLabel.WordBreak)
        textLabel.setSizePolicy(QSizePolicy(QSizePolicy.Expanding, QSizePolicy.Preferred, 0, 0, textLabel.sizePolicy().hasHeightForWidth()))
        textLabel.setFrameShape(self.frame_shape)
        layout1.addWidget(textLabel, 0, 1)
        spacer1 = QSpacerItem(20, 20, QSizePolicy.Expanding, QSizePolicy.Minimum)
        layout1.addItem(spacer1, 0, 2)
        textLabel.setText(text)
        pushButton.setText(button_text)
        icon.setPixmap(pixmap)
        self.connect(pushButton, SIGNAL('clicked()'), button_func)
        self.addWidget(widget, str(title))

    
    def __tr(self, s, c = None):
        return qApp.translate('DevMgr4', s, c)


